%define vers 4.2.2
# This spec is really maintained only for RHEL 5 and 6 at this time. 
#  Building on Fedora is only an afterthought.
#
# comment the line below if you have CentOS, Fedora Core, or another OS
%define rel %(if [ -f /etc/redhat-release ]; then cat /etc/redhat-release | cut -d' ' -f7 | cut -d'.' -f1; fi)

%define enable_webkdc 1
# uncomment the line below and add a leading "%" to try to gather the 
#  version of CentOS
#define rel %(if [ -f /etc/redhat-release ]; then cat /etc/redhat-release | cut -d' ' -f3 | cut -d'.' -f1; fi)

# uncomment the line below and add a leading "%" to try to gather the 
#  version of FC
#define rel %(if [ -f /etc/fedora-release ]; then cat /etc/fedora-release | cut -d' ' -f4; fi)

Summary: Web authentication (webauth) module for the Apache 2.x web servers
Name: webauth
Version: %{vers}
# set the appropriate release if possible
# Change the "EL" portion of the release below if you want.
Release: 2.EL%{rel}
Group: System Environment/Daemons
URL: http://webauth.stanford.edu
Source: http://webauth.stanford.edu/dist/webauth-%{vers}.tar.gz
Source1: cs-webkdc-templates.tgz
Source2:	cs-webauth.conf
Source3:	cs-webkdc.conf
Source4:	cs-webkdc-perl.conf
Patch0: webauth.load.i386.diff
Patch1: webauth.load.x86_64.diff
#Patch2: rhel5.diff
License: MIT
BuildRoot: /var/tmp/%{name}-buildroot
Vendor: Stanford University
Distribution: EL

BuildRequires: httpd-devel >= 2.0.40-11, openssl-devel >= 0.9.7, e2fsprogs-devel, krb5-devel, curl-devel
Requires: httpd >= 2.0.40
Requires: mod_ssl
Requires: cyrus-sasl-gssapi
Requires: curl
BuildRequires: libtool
BuildRequires: openldap-devel
BuildRequires: glibc-common

%ifarch i386
BuildArch: i686
%endif

%description
WebAuth is an authentication system for web pages and web applications. The
first time a user attempts to access a web page protected by WebAuth, they will
be sent to a central login server (weblogin.stanford.edu at Stanford) and
prompted to authenticate. Normally, they will be asked for a username and
password, although other authentication methods are possible. Once the user has
logged in, the weblogin server will send their encrypted identity back to the
original web page they were trying to access. Their identity will also be
stored in a cookie set by the weblogin server and they will not need to
authenticate again until their credentials expire, even if they visit multiple
protected web sites.

%package webkdc
Summary: WebAuth WebKDC module for the Apache 2.x web servers.
Group: System Environment/Daemons
Requires: webauth = %{PACKAGE_VERSION}

%description webkdc
WebAuth is an authentication system for web pages and web applications. This 
package contains the WebKDC module.

%prep

%setup -q 
#%patch2 -p1
# patch for either x86_64 or i386
%ifarch x86_64
%patch1
%else
%patch0
%endif

%build
./configure --prefix=/usr --with-openssl=/usr --with-curl=/usr --with-apxs=/usr/bin/apxs --with-ldap=/usr --with-krb5=/usr --without-remctl --enable-webkdc
make 

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%ifarch x86_64
%define _libdir /usr/lib64
%endif

mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules
install -m 755 lib/.libs/libwebauth.so.7.0.0 $RPM_BUILD_ROOT%{_libdir}

install -m 755 modules/ldap/.libs/mod_webauthldap.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules
install -m 755 modules/webauth/.libs/mod_webauth.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules


ln -sf libwebauth.so.7.0.0 $RPM_BUILD_ROOT%{_libdir}/libwebauth.so
ln -sf libwebauth.so.7.0.0 $RPM_BUILD_ROOT%{_libdir}/libwebauth.so.7

mkdir -p $RPM_BUILD_ROOT%{_bindir} $RPM_BUILD_ROOT/usr/share/man/man1/
install -m 755 tools/.libs/wa_keyring $RPM_BUILD_ROOT%{_bindir}
install -m 644 tools/wa_keyring.1 $RPM_BUILD_ROOT/usr/share/man/man1/wa_keyring.1
gzip $RPM_BUILD_ROOT/usr/share/man/man1/wa_keyring.1


mkdir -p $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}
install -m 644 INSTALL $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}
install -m 644 README $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}/README
install -m 644 NEWS $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}
cp -rp conf $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}
# convert to UTF-8
# cp -rp docs $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}
for i in `ls docs | grep -v diagram`; do 
    iconv -f ISO-8859-1 -t UTF-8 docs/$i > $RPM_BUILD_ROOT/$RPM_DOC_DIR/webauth-%{vers}/$i
done

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d
cp -rp conf/debian/webauth.conf $RPM_BUILD_ROOT/etc/httpd/conf.d/
cp -rp conf/debian/webauth.load $RPM_BUILD_ROOT/etc/httpd/conf.d/webauth-load.conf
cp -rp conf/debian/webauthldap.conf $RPM_BUILD_ROOT/etc/httpd/conf.d/
cp -rp conf/debian/webauthldap.load $RPM_BUILD_ROOT/etc/httpd/conf.d/webauthldap-load.conf
mkdir -p $RPM_BUILD_ROOT/etc/webauth/
mkdir -p $RPM_BUILD_ROOT/var/lib/webauth/

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/webkdc

mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc
mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc/WebKDC
mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc/generic
mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc/generic/images
mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc/generic/templates

%if %{?enable_webkdc:1}
install -c weblogin/login.fcgi $RPM_BUILD_ROOT%{_prefix}/webkdc/login.fcgi
install -c weblogin/logout.fcgi $RPM_BUILD_ROOT%{_prefix}/webkdc/logout.fcgi
install -c -m 644 perl/lib/WebKDC.pm $RPM_BUILD_ROOT%{_prefix}/webkdc/WebKDC.pm
%endif

#for f in images/*.png ; do
#	install -c -m 644 $f $RPM_BUILD_ROOT%{_prefix}/webkdc/generic/$f
#done
#for f in WebKDC/*.pm ; do \
#	install -c -m 644 $f $RPM_BUILD_ROOT%{_prefix}/webkdc/$f; \
#done
#for f in templates/*.tmpl ; do \
#	install -c -m 644 $f $RPM_BUILD_ROOT%{_prefix}/webkdc/generic/$f; \
#done
#
#install -c -m 644 templates/help.html $RPM_BUILD_ROOT%{_prefix}/webkdc/generic/help.html
#popd

# WebAuth perl bindings

## CSD-CF: Modifications to enable perl bindings ------------------------------------
pushd perl
CFLAGS="$RPM_OPT_FLAGS" %{__perl} Makefile.PL
make pure_install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT
popd

find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'


## CSD-CF: Modifications to enable webkdc package ------------------------------------
%if 0%{?enable_webkdc:1}
# Files for WebKDC

install -m 755 modules/webkdc/.libs/mod_webkdc.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules

mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc/cs
mkdir -p $RPM_BUILD_ROOT%{_prefix}/webkdc/cs/templates
tar xzf %{SOURCE1}
pushd cs-webkdc-templates
for f in *.tmpl; do
install -c -m 644 $f $RPM_BUILD_ROOT%{_prefix}/webkdc/cs/templates/$f;
done
popd

#ln -s cs/templates $RPM_BUILD_ROOT%{_prefix}/webkdc/templates;

install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/httpd/conf.d/webauth.conf
install -c -m 644 %{SOURCE3} $RPM_BUILD_ROOT/etc/httpd/conf.d/webkdc.conf

mkdir -p $RPM_BUILD_ROOT/etc/webkdc
install -c -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/webkdc/webkdc.conf
%endif
# CSD-CF: End Local modifications ---------------------------------------------------------------

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_libdir}/httpd/modules/*
%{_libdir}/libweb*
%{_bindir}/wa_keyring
%config(noreplace) /etc/httpd/conf.d/*
%doc %{_docdir}/webauth-%{vers}
%doc /usr/share/man/man1/wa_keyring.1*
%dir /etc/webauth
%defattr(-,root,apache,0770)
%dir /var/lib/webauth

# Surely this could be better
#%dir %{_libdir}/perl5/site_perl/5.8.8/*-linux-thread-multi/*
#%dir %{_libdir}/perl5/site_perl/5.8.8/*-linux-thread-multi/auto/WebAuth/*
#%dir %{_libdir}/perl5/site_perl/5.8.8/*-linux-thread-multi/WebKDC/*
%dir /usr/local/lib64/perl5/*
%dir /usr/local/lib64/perl5/WebAuth/*

%if %{?enable_webkdc:1}
%files webkdc
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_webkdc*
#%{_libdir}/mod_webkdc*
%{_prefix}/webkdc
%config(noreplace) /etc/httpd/conf.d/webkdc.conf
%config(noreplace) /etc/webkdc/webkdc.conf
%defattr(-,apache,root)
%dir /etc/httpd/conf/webkdc
%dir /usr/webkdc/*
%dir /usr/local/lib64/perl5/*
%dir /usr/local/lib64/perl5/WebAuth/*
/usr/local/lib64/perl5/WebAuth.pm
/usr/local/lib64/perl5/WebAuth/Exception.pm
/usr/local/lib64/perl5/WebAuth/Key.pm
/usr/local/lib64/perl5/WebAuth/Keyring.pm
/usr/local/lib64/perl5/WebAuth/KeyringEntry.pod
/usr/local/lib64/perl5/WebAuth/Token.pm
/usr/local/lib64/perl5/WebKDC.pm
/usr/local/lib64/perl5/WebLogin.pm
%{_prefix}/local/lib64/perl5/WebKDC/*
%{_prefix}/local/lib64/perl5/WebAuth/Token/*
%{_prefix}/local/lib64/perl5/auto/WebAuth/*
%{_prefix}/local/share/man/man3/*
#%dir /etc/httpd/conf/webkdc
#%dir /etc/webkdc/*
#%dir /usr/local/lib64/perl5/WebKDC/*
#%dir /usr/local/lib64/perl5/WebAuth/Token/*
#%dir /usr/local/lib64/perl5/auto/WebAuth/*
#%dir /usr/local/share/man/man3/*
%endif

%post
service httpd condrestart

%postun -p /sbin/ldconfig

%changelog
* Wed Jul 25 2012 Darren Patterson <darrenp1@stanford.edu> 4.2.2-1
- updated to 4.2.2

* Thu Mar 29 2012 Darren Patterson <darrenp1@stanford.edu> 4.1.0-2
- adjust configure: --without-remctl 

* Wed Mar 28 2012 Darren Patterson <darrenp1@stanford.edu> 4.1.0-1
- updated to 4.1.0, remove unneeded req remctl-client/devel

* Fri Dec 2 2011 Darren Patterson <darrenp1@stanford.edu> 4.0.2-1
- updated to 4.0.2

* Tue Oct 11 2011 Darren Patterson <darrenp1@stanford.edu> 4.0.1-1
- updated to 4.0.1

* Fri Sep 23 2011 Darren Patterson <darrenp1@stanford.edu> 3.7.4-1
- updated to 3.7.4

* Fri Aug 13 2010 Darren Patterson <darrenp1@stanford.edu> 3.7.3-1
- updated to 3.7.3

* Fri Aug 13 2010 Darren Patterson <darrenp1@stanford.edu> 3.7.2-1
- updated to 3.7.2

* Fri Jul 23 2010 Darren Patterosn <darrenp1@stanford.edu> 3.7.1-1
- updated to 3.7.1

* Thu Nov 12 2009 Darren Patterson <darrenp1@stanford.edu> 3.6.1-3
- removed httpd condrestart.

* Mon Nov 9 2009 Darren Patterson <darrenp1@stanford.edu> 3.6.1-2
- include real wa_keyring.
- rpmlint cleanup.
- removed RHEL3 support (hack to use ancient krb5-SU).

* Thu Jul 16 2009 Darren Patterson <darrenp1@stanford.edu> 3.6.1-1
- built 3.6.1

* Fri Jun 13 2008 Darren Patterson <darrenp1@stanford.edu> 3.6.0-2
- rebuild without krb5-SU

* Wed Apr 2 2008 Darren Patterson <darrenp1@stanford.edu> 3.6.0-1
- updated to 3.6.0.

* Mon May 7 2007 Darren Patterson <darrenp1@stanford.edu> 3.5.4-1
- update to 3.5.4

* Wed Apr 4 2007 Darren Patterson <darrenp1@stanford.edu> 3.5.3-2
- Substantial changes to use configuration as similar to deb as possible.
- Stanford users will now need the stanford-server RPM.

* Thu Oct 5 2006 Darren Patterson <darrenp1@stanford.edu> 3.5.3-1
- updated for 3.5.3

* Tue Sep 12 2006 Digant C Kasundra <digant@stanford.edu> 3.5.1-4
- Moved stanford-webauth.conf back into the httpd conf.d dir to match the behavior of the debian package

* Thu Jun 29 2006 Darren Patterson <darrenp1@stanford.edu> 3.5.1-3
- Changed rhel3 requirements to include openldap

* Mon Jun 12 2006 Darren Patterson <darrenp1@stanford.edu> 3.5.1-2
- Made an attempt to support fedora core and added comments for users who may want to try and change/update the spec later to fix FC/CentOS(/other OS?) build issues.
- Moved stanford-webauth.conf to doc dir instead of httpd conf.d dir.

* Sun Jun 11 2006 Darren Patterson <darrenp1@stanford.edu> 3.5.1-1
- updated release for 64-bit fixes 

* Wed May 31 2006 Darren Patterson <darrenp1@stanford.edu> 3.5.0-2
- removed configure option that made rhel3 balk 

* Tue May 30 2006 Darren Patterson <darrenp1@stanford.edu> 
- added rel option for different rhel releases

* Mon May 22 2006 Darren Patterson <darrenp1@stanford.edu> 
- changed httpd restart to "condrestart"

* Fri May 19 2006 Darren Patterson <darrenp1@stanford.edu> 3.5.0
- updated to latest release
- removed module *.la and *.a files because they are extraneous.
- changed README to install as README instead of LICENSE

* Thu Apr 14 2005 Joe Little <jlittle@stanford.edu> 3.2.4-2
- fixed inclusion of default configs

* Thu Mar 10 2005 Joe Little <jlittle@stanford.edu> 3.2.4-1
- fixed webauthldap/webauth mod builds
- fixed library versioning of symlinks
- still lacks webkdc build

* Tue Apr  1 2003 Joe Little <jlittle@stanford.edu> 3.0.0-1
- first build
- enable-perl is not used; no perl bindings packaged
